package junior;
import junior.core.*;

public class Jr extends JrBase
{
   static public Identifier StringIdentifier(String str){ return new StringIdentifier(str); }
   static public IdentifierWrapper StringWrapper(String str){ return ConstWrapper(StringIdentifier(str)); }
   static public Configuration StringConfig(String str){ return new Presence(StringWrapper(str)); }
   // Machines 
   static public SyncMachine SyncMachine(){ return JrBase.SyncMachine(Nothing()); }
   static public UnSyncMachine UnSyncMachine(){ return JrBase.UnSyncMachine(Nothing()); }
   // Repeat
   static public Program Repeat(int count, Program body){ return JrBase.Repeat(ConstWrapper(count),body); }  
   // if
   static public Program If(BooleanWrapper cond,Program thenInst){ return JrBase.If(cond,thenInst,Nothing()); }
   // Generate
   static public Program Generate(Identifier event,ObjectWrapper owrap){ return JrBase.Generate(ConstWrapper(event),owrap); } 
   static public Program Generate(IdentifierWrapper iwrap,Object value){ return JrBase.Generate(iwrap,ConstWrapper(value)); }    
   static public Program Generate(Identifier event,Object value){ return JrBase.Generate(ConstWrapper(event),ConstWrapper(value)); }
   static public Program Generate(IdentifierWrapper iwrap){ return JrBase.Generate(iwrap,ConstWrapper(Jr.NO_VALUE)); }
   static public Program Generate(Identifier event){ return Generate(event,ConstWrapper(Jr.NO_VALUE)); }
   // Await    
   static public Program Await(IdentifierWrapper wrapper){ return JrBase.Await(Presence(wrapper)); }
   static public Program Await(Identifier event){ return JrBase.Await(Presence(event)); }
   // Until
   static public Program Until(Configuration config, Program body){ return JrBase.Until(config,body,Nothing()); }   
   static public Program Until(IdentifierWrapper wrapper, Program body, Program handler){ return JrBase.Until(Presence(wrapper),body,handler); }   
   static public Program Until(IdentifierWrapper wrapper, Program body){ return Until(wrapper,body,Nothing()); }   
   static public Program Until(Identifier event, Program body, Program handler){ return Until(ConstWrapper(event),body,handler); }
   static public Program Until(Identifier event, Program body){ return Until(ConstWrapper(event),body,Nothing()); }
  // When
   static public Program When(Configuration config,Program thenInst){ return JrBase.When(config,thenInst,Nothing()); }  
   static public Program When(IdentifierWrapper wrapper,Program thenInst,Program elseInst){ return JrBase.When(Presence(wrapper),thenInst,elseInst); }  
   static public Program When(IdentifierWrapper wrapper,Program thenInst){ return When(wrapper,thenInst,Nothing()); }  
   static public Program When(Identifier event, Program thenInst, Program elseInst){ return When(ConstWrapper(event),thenInst,elseInst); }
   static public Program When(Identifier event, Program thenInst){ return When(ConstWrapper(event),thenInst,Nothing()); }
   // Control
   static public Program Control(Identifier event, Program body){ return JrBase.Control(ConstWrapper(event),body); }   
   // Freezable      
   static public Program Freezable(Identifier event, Program body){ return JrBase.Freezable(ConstWrapper(event),body); }
   // Link   
   static public Program Link(Object object, Program body){ return JrBase.Link(ConstWrapper(object),body); } 
   // Configurations  
   static public Configuration Presence(Identifier event){ return JrBase.Presence(ConstWrapper(event)); }   
   /********* STRINGS *********************/ 
   static public Program Generate(String event,Object val){ return JrBase.Generate(StringWrapper(event),ConstWrapper(val)); }
   static public Program Generate(String event){ return Generate(StringWrapper(event)); }
   static public Program Await(String event){ return JrBase.Await(StringConfig(event)); }
   static public Program Control(String event, Program body){ return JrBase.Control(StringWrapper(event),body); }
   static public Program Local(String event, Program body){ return JrBase.Local(StringIdentifier(event),body); }
   static public Program Freezable(String event, Program body){ return JrBase.Freezable(StringWrapper(event),body); }
   // until
   static public Program Until(String event, Program body, Program handler){ return JrBase.Until(StringConfig(event),body,handler); }
   static public Program Until(String event, Program body){ return JrBase.Until(StringConfig(event),body,Nothing()); }
   // when
   static public Program When(String event,Program thenInst, Program elseInst){ return JrBase.When(StringConfig(event),thenInst,elseInst); }
   static public Program When(String event,Program thenInst){ return JrBase.When(StringConfig(event),thenInst,Nothing()); }  
   // configurations
   static public Configuration Presence(String event){ return JrBase.Presence(StringWrapper(event)); } 
   static public Configuration Not(String event){ return JrBase.Not(Presence(event)); }
}
