package junior.core;
import junior.Configuration;

public class And extends Config 
{
  final public Config config1,config2;
  
  public And(Configuration c1, Configuration c2){ config1 = (Config)c1; config2 = (Config)c2; }
  public void reset(){ config1.reset(); config2.reset(); }

  public String toString(){ return "("+config1+" and "+config2+")"; }

  public boolean equals(Config other){ 
     return super.equals(other) 
         && config1.equals(((And)other).config1)
         && config2.equals(((And)other).config2); 
  }
  
  public boolean fixed(EnvironmentImpl env){ 
    boolean b1 = config1.fixed(env), b2 = config2.fixed(env);
    if (b1 && !config1.eval(env)) return true;
    if (b2 && !config2.eval(env)) return true;
    return b1 && b2; 
  }

  public boolean eval(EnvironmentImpl env){ return config1.eval(env) && config2.eval(env); }

  public Configuration copy(){ return new And(config1.copy(),config2.copy()); }
}
