package junior.core;
import junior.*;

public class BasicContext implements Flags, UnSyncMachine
{
   public Instant instant;
   public EnvironmentImpl env;
   public Program toAdd = Jr.Nothing();
   public boolean somethingToAdd = false;

   // constructor    
   public BasicContext(Program program){ 
      this.instant = new Instant(program);
      buildEnvironment();
   }

   // building the environment
   public void buildEnvironment(){ env = new EnvironmentImpl(); }

   // dynamic add method for next instant
   public void add(Program inst){ 
      toAdd = Jr.Par(toAdd,inst);
      somethingToAdd = true;
   }
   protected void performAddings(){
      if (somethingToAdd == false) return;
      instant = new Instant(Jr.Par(toAdd,instant.body));
      toAdd = Jr.Nothing();
      somethingToAdd = false;
   } 

   // generate methods
   public void generate(Identifier event){ this.generate(event,Jr.NO_VALUE); }  
   public void generate(Identifier event, Object obj){ env.generate(event,obj); }   
 
   // get frozen programs
   public Program getFrozen (Identifier event){ return env.getFrozen(event); }

   // react method
   public boolean react(){
      performAddings();
      MicroState s = instant.rewrite(env); 
      instant = (Instant)s.term;
      env.newInstant();
      return (TERM == s.flag);
   }   
}