package junior.core;
import junior.*;

public class Control extends UnaryInstruction
{
  final public Presence presence;
  
  public Control(Presence presence, Program body){ super(body); this.presence = presence; }
  
  public String toString(){ return PrintInstruction.Control(""+presence,""+body); }

  public MicroState rewrite(EnvironmentImpl env){
     if (presence.sat(env)){
         MicroState s = body.rewrite(env);
         return new MicroState(s.flag,new Control(presence,s.term)); 
     }
     if (presence.unsat(env)) return new MicroState(STOP,this);
     return unknown();
  }
  
  public Program copy(){ return new Control((Presence)presence.copy(),body.copy()); }
}
