package junior.core;
import java.util.*;
import junior.*;

public class EnvironmentImpl implements Environment, Cloneable
{
   public long instant = 1;
   public boolean eoi, move;												// end of instants
   public Hashtable eventSet = new Hashtable(); 							// events
   public Hashtable frozen = new Hashtable(), tempFrozen = new Hashtable();	// frozen programs
   public Object linkedObject;												// implicit object
   // for debug
   public String toString(){ return ""+eventSet; }
   //linked object
   public Object linkedObject(){ return linkedObject; }  
   // event values
   public Object[] currentValues (Identifier event){ 
      return getEventData(event).currentValues(instant); 
   }
   public Object[] previousValues (Identifier event){ 
      return getEventData(event).previousValues(instant); 
   }
   // events
   public EventDataImpl getEventData(Identifier event){
      EventDataImpl eventData = (EventDataImpl)eventSet.get(event);
      if (eventData == null){
         eventData = new EventDataImpl();
         eventSet.put(event,eventData);
      }
      return eventData;  
   }
   public boolean isGenerated(Identifier event){
      return getEventData(event).isGenerated(instant);
   }
   public void generate(Identifier event,Object val){
      EventDataImpl eventData = getEventData(event);
      if (!eventData.isGenerated(instant)) move = true;
      eventData.generate(instant,val);
   }   
   // frozen instructions
   public void storeFrozen(Identifier event,Program program){ 
      Program old = (Program)tempFrozen.get(event);
      Program actual = (old == null) ? program : Jr.Par(old,program);
      System.out.println("STORE "+actual+" ASSOCIATED TO "+event);
      tempFrozen.put(event,actual);
   }
   public Program getFrozen(Identifier event){ return (Program)frozen.remove(event); }
   // new instant
   public void newInstant(){
      instant++;
      eoi = move = false;
      //System.out.println("SWAP ");
      frozen = tempFrozen; 
      tempFrozen = new Hashtable();
   }
}
