package junior.core;
import junior.*;
import java.util.*;

public class EventDataImpl implements EventData, Cloneable
{
   public long generated = 0, lastActualization = 0;
   public Vector current = null, previous = null;

   public void actualize(long instant){
     if (lastActualization == instant) return;
     previous = (instant == lastActualization+1) ? current : null;
     current = null;
     lastActualization = instant;
   }
   public Object[] currentValues (long instant){ 
      actualize(instant);
      if (current == null) return null;
      Object[] res = new Object[current.size()];
      current.copyInto(res);
      return res;  
   }
   public Object[] previousValues (long instant){ 
      actualize(instant);
      if (previous == null) return null;
      Object[] res = new Object[previous.size()];
      previous.copyInto(res);
      return res;  
   }
   public void generate(long instant){ this.generate(instant,Jr.NO_VALUE); }
   public void generate(long instant,Object val){ 
      actualize(instant); 
      this.generated = instant; 
      if (val == null) val = Jr.NULL_VALUE;
      if (current == null) current = new Vector();
      current.addElement(val);
   }
   public boolean isGenerated(long instant){ 
      actualize(instant); return instant == generated; 
   }
   public EventData copy(){ 
      EventDataImpl res;
      try{ 
         res = (EventDataImpl)clone(); 
         res.current = (current == null) ? null : (Vector)current.clone();
         res.previous = (previous == null) ? null : (Vector)previous.clone();      
      }catch(CloneNotSupportedException e){ throw new InternalError(""+e); }      
      return res;
   }
}