package junior.core;
import java.util.*;
import junior.*;

public class ExecContext extends BasicContext implements Machine, SyncMachine
{
   public Vector toGenerate = new Vector();

   // constructor    
   public ExecContext(Program program){ super(program); }

   // synchronized dynamic add method for next instant
   public void add(Program inst){
      synchronized(toAdd){ super.add(inst); } 
   }   
   protected void performAddings(){
      synchronized(toAdd){ super.performAddings(); }
   }

   // synchronized generate methods for next instant
   public void generate(Identifier event, Object obj){ 
      synchronized(toGenerate){ 
         toGenerate.addElement(new GenerateOrder(event,obj)); 
      }
   }   
   public void generate(Identifier event){ this.generate(event,Jr.NO_VALUE); } 
    
   protected void performGenerations(){
      synchronized(toGenerate){
         if (toGenerate.size() > 0){
            Enumeration list = toGenerate.elements();
            while (list.hasMoreElements()){
                GenerateOrder order = (GenerateOrder)list.nextElement();
                super.generate(order.identifier,order.value);
            } 
            toGenerate.removeAllElements();
         }
      }     
   }

   // react method
   public synchronized boolean react(){
      performGenerations();
      return super.react();
   }   
}
