package junior.core;
import junior.*;

public class Freezable extends UnaryInstruction
{
  final public Presence presence;
  
  public Freezable(Presence presence,Program body){ super(body); this.presence = presence; }

  public String toString(){ return PrintInstruction.Freezable(""+presence,""+body); }
  
  public MicroState rewrite(EnvironmentImpl env){
     MicroState s = body.rewrite(env);
     if (STOP != s.flag) return new MicroState(s.flag, new Freezable(presence,s.term));
     return new FreezableStar(presence,s.term).rewrite(env);
  }
  
  public Program copy(){ return new Freezable((Presence)presence.copy(),body.copy()); }
}
