package junior.core;
import junior.*;

public class FreezableStar extends UnaryInstruction
{
  final public Presence presence;
  
  public FreezableStar(Presence presence,Program body){ super(body); this.presence = presence; }

  public MicroState rewrite(EnvironmentImpl env){
     if (presence.sat(env)){
        env.storeFrozen(presence.event,body.copy()); // the body is copied
        return new MicroState(((env.eoi) ? STOP : TERM),new Nothing());
     }
     if (presence.unsat(env)) return new MicroState(STOP,new Freezable(presence,body)); 
     return unknown();
  }
  
  public Program copy(){ return new FreezableStar((Presence)presence.copy(),body.copy()); }
}