package junior.core;
import junior.*;

public class IODecl extends UnaryInstruction
{
   final public IdentifierWrapper wrapper;
   final public Identifier local;

   public IODecl(IdentifierWrapper wrapper, Identifier local, Program body){ 
      super(body); this.wrapper = wrapper;  this.local = local;
   }

   public String toString(){ return PrintInstruction.IODecl(wrapper,""+local,""+body); }

   public MicroState rewrite(EnvironmentImpl env){
      return new IODeclStatic(wrapper.evaluate(env),local,body).rewrite(env);  
   }
   
   public Program copy(){ return new IODecl(wrapper,local,body.copy()); } 
}