package junior.core;
import junior.*;


public class IODeclStatic extends UnaryInstruction
{
    final public Identifier extern;
    final public Identifier local;
    public EventData localEvent, save;
        
    public IODeclStatic(Identifier extern, Identifier local, EventData localEvent, Program body){ 
       super(body); this.local = local; this.localEvent = localEvent; this.extern = extern;
    }
    public IODeclStatic(Identifier extern, Identifier intern, Program body){
       this(extern,intern,new EventDataImpl(),body);
    }
    
    public String toString(){ return "inputoutput "+extern+" is "+local+" in "+body+" end"; }
 
    public void swapIn(EnvironmentImpl env){
       if (extern.equals(local)) return;
       save = env.getEventData(local);
       env.eventSet.put(local,env.getEventData(extern));
    }
    
    public void swapOut(EnvironmentImpl env){
       if (extern.equals(local)) return;
       env.eventSet.put(extern,env.getEventData(local));
       localEvent = env.getEventData(local);
       env.eventSet.put(local,save);
    }
    public MicroState rewrite(EnvironmentImpl env){
       swapIn(env);
       MicroState res = body.rewrite(env);
       swapOut(env);
       return new MicroState(res.flag,new IODeclStatic(extern,local,localEvent.copy(),res.term));
    }
       
    public Program copy(){ return new IODeclStatic(extern,local,localEvent.copy(),body.copy()); }  
}
