package junior.core;
import junior.*;

public class LinkStatic extends UnaryInstruction
{  
   final public Object self;

   public LinkStatic(Object self, Program body){ super(body); this.self = self; }   

   public MicroState rewrite(EnvironmentImpl env){ 
      Object save = env.linkedObject;
      env.linkedObject = self;
      MicroState res = body.rewrite(env); 
      env.linkedObject = save;
      return new MicroState(res.flag,new LinkStatic(self,res.term)); 
   }
  
   public Program copy(){ return new LinkStatic(self,body.copy()); }
}