package junior.core;
import junior.*;

public class Local extends UnaryInstruction
{
    final public Identifier local;
    public EventData localEvent, save;

    public Local(Identifier local, EventData localEvent, Program body){ 
       super(body); this.local = local; this.localEvent = localEvent;
    }
    
    public String toString(){ return PrintInstruction.Local(""+local,""+body); }

    public void swapIn(EnvironmentImpl env){
       save = env.getEventData(local);
       env.eventSet.put(local,localEvent);
    }
    
    public void swapOut(EnvironmentImpl env){
       localEvent = env.getEventData(local);
       env.eventSet.put(local,save);
    }
    
    public MicroState rewrite(EnvironmentImpl env){
       swapIn(env);
       MicroState res = body.rewrite(env);
       swapOut(env);
       return new MicroState(res.flag,new Local(local,localEvent.copy(),res.term));
   }
   
   public Program copy(){ return new Local(local,localEvent.copy(),body.copy()); }
}
