package junior.core;
import junior.*;

public class Presence extends Config
{
  final public IdentifierWrapper wrapper;
  public boolean evaluated = false;
  public Identifier event;

  public Presence(IdentifierWrapper wrapper){ this.wrapper = wrapper; }
  public void reset(){ evaluated = false; }
  
  public String toString(){ return ""+wrapper; }
  
  public boolean equals(Config config){
     return super.equals(config) 
         && wrapper == ((Presence)config).wrapper
         && (!evaluated || event.equals(((Presence)config).event));
  } 
   
  public boolean fixed(EnvironmentImpl env){ 
     if(evaluated == false){ event = wrapper.evaluate(env); evaluated = true; }     
     return env.isGenerated(event) || env.eoi; 
  }
  
  public boolean eval(EnvironmentImpl env){ return env.isGenerated(event); }
  
  public Configuration copy(){ return new Presence(wrapper); }
}
