package junior.core;
import junior.*;

public class RepeatStatic extends UnaryInstruction
{
  final public int count;

  public RepeatStatic(int count,Program body){ super(body); this.count = count; }
  
  public String toString(){ return "loop {"+count+"} "+body+" end"; }
      
  public MicroState rewrite(EnvironmentImpl env){
     if (count <= 0) return new MicroState(TERM,new Nothing());
     return new Seq(body,new RepeatStatic(count-1,body)).rewrite(env);
  }
  
  public Program copy(){ return new RepeatStatic(count,body.copy()); }
}
