package junior.core;
import junior.*;

public class Until extends BinaryInstruction
{
  final public Config config;
  
  public Until(Configuration config, Program body, Program handler){ 
     super(body,handler); this.config = (Config)config;
  }
  public String toString(){ return PrintInstruction.Until(""+config,""+left,""+right); }
  
  public MicroState rewrite(EnvironmentImpl env){
     MicroState s = left.rewrite(env);
     if (STOP != s.flag) return new MicroState(s.flag, new Until(config,s.term,right));
     return new UntilStar(config,s.term,right).rewrite(env);
  }
  
  public Program copy(){ return new Until(config.copy(),left.copy(),right.copy()); }
}
