package junior.core;
import junior.*;

public class UntilStar extends BinaryInstruction
{
  final public Config config;
  
  public UntilStar(Configuration config, Program body, Program handler){ 
     super(body,handler); this.config = (Config)config; 
  }

  public MicroState rewrite(EnvironmentImpl env){
     if (config.sat(env)){
        if (! env.eoi) return right.rewrite(env); 
        else return  new MicroState(STOP,right);
     }
     if (config.unsat(env)) return new MicroState(STOP,new Until(config,left,right)); 
     return unknown();
  }
  
  public Program copy(){ return new UntilStar(config.copy(),left.copy(),right.copy()); }
}
